classification
Title: Crash, 2.7.1, Tkinter and threads and line drawing
Type: behavior Stage:
Components: Documentation Versions: Python 3.2, Python 2.7
process
Status: closed Resolution: duplicate
Dependencies: Superseder: Python quits on running tkinter code with threads
View: 16823
Assigned To: docs@python Nosy List: Jackmoo, PythonInTheGrass, brian.curtin, cgohlke, docs@python, terry.reedy
Priority: normal Keywords:

Created on 2011-01-27 17:01 by PythonInTheGrass, last changed 2015-05-24 15:31 by terry.reedy. This issue is now closed.

Files
File name Uploaded Description Edit
TkinterCrash.py PythonInTheGrass, 2011-01-27 17:01 script to crash Tkinter
TkinterCrash2.py PythonInTheGrass, 2011-01-28 14:54
Messages (9)
msg127201 - (view) Author: Scott M (PythonInTheGrass) Date: 2011-01-27 17:01
Running on dual core Windows XP. 

The function should draw a parabolicish shape for each click on launch. But if you click Launch over and over, very fast, you get bizarre crashes instead: Python.exe has encoutered a problem, yadda. tcl85.dll. It rarely takes many clicks.

Apologies for the coding style; this has been hacked down from a larger app.

In the console window:

Exception in thread Thread-5:
Traceback (most recent call last):
  File "C:\Python27\lib\threading.py", line 530, in __bootstrap_inner
    self.run()
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash.py"
, line 47, in run
    self.app.arrival_122((self.target, y, z))
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash.py"
, line 100, in arrival_122
    self.label.config(text= str(message[0])+ " " + str(message[1]))
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 1202, in configure
    return self._configure('configure', cnf, kw)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 1193, in _configure
    self.tk.call(_flatten((self._w, cmd)) + self._options(cnf))
TclError: invalid command name "source C:/Python27/tcl/tk8.5/menu.tcl"

Exception in thread Thread-4:
Traceback (most recent call last):
  File "C:\Python27\lib\threading.py", line 530, in __bootstrap_inner
    self.run()
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash.py"
, line 47, in run
    self.app.arrival_122((self.target, y, z))
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash.py"
, line 125, in arrival_122
    self.graph.create_line(self.trackCoordinates[tn], new_yz)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2201, in create_line
    return self._create('line', args, kw)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2189, in _create
    *(args + self._options(cnf, kw))))
TclError: invalid command name "line"

Also saw:
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2201, in create_line
    return self._create('line', args, kw)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2189, in _create
    *(args + self._options(cnf, kw))))
TclError: bad option "665.4400009999997": must be addtag, bbox, bind, canvasx, canvasy, cget, configure, coords, create, dchars, delete, dtag, find, focus, gettags, icursor, index, insert, itemcget, itemconfigure, lower, move, postscript, raise, scale, scan, select, type, xview, or yview
msg127222 - (view) Author: Scott M (PythonInTheGrass) Date: 2011-01-27 20:29
To make this more interesting, I'm trying to push for adoption of Python at a scripting tool where I work, and I uncovered this crasher in example code I was about to hand out, under the heading of "look how easy Python is". For obvious reasons I'm holding off on handing out the example; I won't get far selling Python if it crashes when drawing lines... if this is a result of something boneheaded I did, please slap me upside the head ASAP. Conversely if there's a quick fix possible, that will speed Python adoption where I work... thanks.
msg127243 - (view) Author: Christoph Gohlke (cgohlke) Date: 2011-01-28 04:12
Tkinter is not thread safe. You are changing UI elements from a thread that is not the main thread. Use a Queue as described at http://effbot.org/zone/tkinter-threads.htm.
msg127307 - (view) Author: Scott M (PythonInTheGrass) Date: 2011-01-28 14:54
OK, now all calls to Tkinter are funneled to a single thread, through a queue. (Technically there are two threads in Tkinter - one is parked in .mainloop(), the other makes a call to Canvas.create_line and a call to Label.config.) Different crash, but still a crash. This one seems to be mostly consistent; see below and new attached code.

If you're going to tell me that Tkinter simply can never be called by any thread other than the one animating mainloop - in other words, Tkinter calls are only safe within Tkinter callbacks like a Button's command function - then please suggest an alternative library that is sturdier. There's nothing I can do about the fact that multiple threads produce independent data that has to go onto a single graph.

Exception in thread Thread-1:
Traceback (most recent call last):
  File "C:\Python27\lib\threading.py", line 530, in __bootstrap_inner
    self.run()
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash.py", line 68, in run
    self.graph.create_line(element[0], element[1], element[2], element[3])
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2201, in create_line
    return self._create('line', args, kw)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2189, in _create
    *(args + self._options(cnf, kw))))
ValueError: invalid literal for int() with base 10: 'None'

But once I got:

Exception in thread Thread-1:
Traceback (most recent call last):
  File "C:\Python27\lib\threading.py", line 530, in __bootstrap_inner
    self.run()
  File "C:\Documents and Settings\mayos\Desktop\PMT2\MyProjects\TkinterCrash2.py", line 68, in run
    self.graph.create_line(element[0], element[1], element[2], element[3])
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2201, in create_line
    return self._create('line', args, kw)
  File "C:\Python27\lib\lib-tk\Tkinter.py", line 2189, in _create
    *(args + self._options(cnf, kw))))
TclError: can not find channel named "Nonefile13cad48"
msg127316 - (view) Author: Scott M (PythonInTheGrass) Date: 2011-01-28 16:38
Alright. More digging turned up the Tkinter "after" function, aka WM_TIMER for Windowy people like me, and that plus a nonblocking queue get() gets all my drawing operations back into the mainLoop() thread. Voilà, no more crashes.

Let me suggest that page one, sentence one of any Tkinter documentation should begin "Tkinter is not thread safe", with a link to an example of after() and nonblocking get(). I've changed the component to Documentation. This would save a few days for poor sods like me -- I'm used to low level Windows C++ GUI work, where any thread can call any SDK function at any time, and Windows sorts it all out. 

Having to force everything into a single thread, and then poll for my data (*GAG*), is something I thought died in the 80's. Is anyone looking at thread safe GUI libraries?
msg127344 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2011-01-28 21:05
There are other gui libraries with Python interfaces that you can look at. I agree that something in doc about how to feed data from multiple threads would be nice.
msg183769 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2013-03-08 22:55
I have somewhat arbitrary selected #16823 as the issue turned into a tkinter and threads doc issue. I added a note there about mentioning the use of queue.
msg243978 - (view) Author: Jackmoo (Jackmoo) Date: 2015-05-24 11:57
Hi there, recently I also encounter this in windows(7), and my python program occasionally crash and the windows pops 'appcrash' message with tcl8.5.dll error c000005 (access violation).

And this end up related to thread safe problem described as above. Since in my program, I have to build the tkinter UI in another thread (main thread was occupied by other module which blocking), so I can't follow the 'build UI in main thread' solution. My work around is, add a handler which using .after() and get_nowait() to call itself periodically to handle the command in queue.

def commandQueueHandler(self):
    try:
        while 1:
            your_command = self.textCommandQueue.get_nowait()
            if your_command is not None:
                # execute the command ....
            self.Text.update_idletasks()
    except Queue.Empty:
        pass
    self.Text.after(100, self.commandQueueHandler)

Once this method is triggered, just build another thread to put() command in textCommandQueue, then it will be executed periodically.
One thing that should mention is the update_idletasks() should be added after each command execution, otherwise the UI refresh will be slower then expected. (in my case, the scrolling of Text widge is a bit 'sticky' when I pull it. After adding update_idletasks(), it becomes smoother.)

TL:DR,
If you have to run tkinter UI in another thread, add a queue and self-called method with after() and get_nowait() in UI thread to handle the queue. If you want to send command to UI at other thread, just put() the command in the queue of UI thread.
msg243988 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2015-05-24 15:31
Thanks for the report.
History
Date User Action Args
2015-05-24 15:31:13terry.reedysetmessages: + msg243988
2015-05-24 11:57:35Jackmoosetnosy: + Jackmoo
messages: + msg243978
2013-03-08 22:55:32terry.reedysetstatus: open -> closed
superseder: Python quits on running tkinter code with threads
resolution: duplicate
messages: + msg183769
2011-02-01 05:14:26belopolskylinkissue7074 superseder
2011-01-28 21:05:21terry.reedysetversions: + Python 3.2
nosy: + terry.reedy

messages: + msg127344

type: crash -> behavior
2011-01-28 16:38:11PythonInTheGrasssetnosy: + docs@python
messages: + msg127316

assignee: docs@python
components: + Documentation, - Tkinter
2011-01-28 14:54:18PythonInTheGrasssetfiles: + TkinterCrash2.py
nosy: brian.curtin, cgohlke, PythonInTheGrass
messages: + msg127307
2011-01-28 04:12:39cgohlkesetnosy: + cgohlke
messages: + msg127243
2011-01-27 20:29:59PythonInTheGrasssetnosy: brian.curtin, PythonInTheGrass
messages: + msg127222
2011-01-27 17:06:24brian.curtinsetnosy: + brian.curtin
2011-01-27 17:01:03PythonInTheGrasscreate